`include "define.v"

module output_LUT_Bram
( DIN, INIT_ADDR, LUT_MODE, LUT_WRITE, INIT_DATA, CLK, DOUT );

input  [ `COMPR_LUT_ADDR_WIDTH - 1 : 0]    DIN,  INIT_ADDR;
input  [ `COMPR_LUT_DATA_WIDTH - 1 : 0]    INIT_DATA;
input  LUT_MODE, LUT_WRITE,   CLK;
output [ `COMPR_LUT_DATA_WIDTH - 1 : 0]   DOUT; 

wire  [`COMPR_LUT_ADDR_WIDTH - 1 : 0] a = (LUT_MODE) ? INIT_ADDR : DIN;

//module that infers Block RAM.         
spdblockram_op ComprBRAM (
    .clk(CLK), 
    .we(LUT_WRITE), 
    .a(a), 
    .di(INIT_DATA), 
    .do(DOUT)            );

endmodule