//
// makes the sum over ET of the 24 channels
//
module sumET (
	input clock,
	input [24:1] Mask,
	input [9:0] ET1,ET2,ET3,ET4,ET5,ET6,ET7,ET8,
	input [9:0] ET9,ET10,ET11,ET12,ET13,ET14,ET15,ET16,
	input [9:0] ET17,ET18,ET19,ET20,ET21,ET22,ET23,ET24,
	output reg [14:0] etsum
	);

//
// if you add 24 10-bit numbers together, the highest number
// you can get is 5FE8 if all the 10-bit numbers are 0x3FF
// (24*1023=24552=0x5FE8) so you'll need only 15 bits
//
// this calculation should probably be pipelined....be sure to
// not add in stuff from those channels that are masked (although
// Tullio probably already sets them to zero anyway)
//
reg[11:0] p1, p2, p3, p4, p5, p6;
always @ (posedge clock) begin
	p1 <= ( Mask[1] ? 0 : ET1)  + ( Mask[2] ? 0 : ET2) + 
			( Mask[3] ? 0 : ET3)  + ( Mask[4] ? 0 : ET4) ;
	p2 <= ( Mask[5] ? 0 : ET5)  + ( Mask[6] ? 0 : ET6) + 
			( Mask[7] ? 0 : ET7)  + ( Mask[8] ? 0 : ET8) ;
	p3 <= ( Mask[9] ? 0 : ET9)  + (Mask[10] ? 0 : ET10)+ 
			(Mask[11] ? 0 : ET11) + (Mask[12] ? 0 : ET12);
	p4 <= (Mask[13] ? 0 : ET13) + (Mask[14] ? 0 : ET14)+ 
			(Mask[15] ? 0 : ET15) + (Mask[16] ? 0 : ET16);
	p5 <= (Mask[17] ? 0 : ET17) + (Mask[18] ? 0 : ET18)+ 
			(Mask[19] ? 0 : ET19) + (Mask[20] ? 0 : ET20);
	p6 <= (Mask[21] ? 0 : ET21) + (Mask[22] ? 0 : ET22)+ 
			(Mask[23] ? 0 : ET23) + (Mask[24] ? 0 : ET24);
	end
always @ (posedge clock) etsum = p1 + p2 + p3 + p4 + p5 + p6;

endmodule